--- old/usr/src/lib/libzfs/common/libzfs_config.c	2015-09-10 10:06:57.946560214 -0400
+++ new/usr/src/lib/libzfs/common/libzfs_config.c	2015-09-10 10:06:57.950079409 -0400
@@ -26,6 +26,7 @@
 
 /*
  * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /*
@@ -167,7 +168,8 @@
 	zcmd_free_nvlists(&zc);
 
 	/*
-	 * Clear out any existing configuration information.
+	 * Clear out any existing configuration information, and recreate
+	 * the AVL tree.
 	 */
 	cookie = NULL;
 	while ((cn = uu_avl_teardown(hdl->libzfs_ns_avl, &cookie)) != NULL) {
@@ -176,6 +178,8 @@
 		free(cn);
 	}
 
+	uu_avl_recreate(hdl->libzfs_ns_avl);
+
 	elem = NULL;
 	while ((elem = nvlist_next_nvpair(config, elem)) != NULL) {
 		nvlist_t *child;
